searchData={"items":[{"type":"module","title":"ExAzureSpeech.Config","doc":"Configuration module for the Azure Cognitive Services Speech SDK.","ref":"ExAzureSpeech.Config.html"},{"type":"function","title":"ExAzureSpeech.Config.new/1","doc":"Returns a validated basic configuration for the Azure Cognitive Services Speech SDK.  \n\n* `:region` (`t:String.t/0`) - Required. The region where the Azure Cognitive Services is hosted, eg: 'westus'\n\n* `:auth_key` (`t:String.t/0`) - Required. The Subscription Key for the Azure Cognitive Services","ref":"ExAzureSpeech.Config.html#new/1"},{"type":"type","title":"ExAzureSpeech.Config.t/0","doc":"","ref":"ExAzureSpeech.Config.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.KeyValue","doc":"Provides a macro for defining a module with a set of key-value pairs.","ref":"ExAzureSpeech.Common.KeyValue.html"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Responses.EndDetected","doc":"Represents the end of a speech recognition session.","ref":"ExAzureSpeech.SpeechToText.Responses.EndDetected.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.EndDetected.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.EndDetected.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Responses.PronunciationAssessment","doc":"Overall pronunciation assessment for the Evaluated Speech.","ref":"ExAzureSpeech.SpeechToText.Responses.PronunciationAssessment.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.PronunciationAssessment.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.PronunciationAssessment.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Auth.Client","doc":"Client to authenticate with the Azure Cognitive Services API","ref":"ExAzureSpeech.Auth.Client.html"},{"type":"function","title":"ExAzureSpeech.Auth.Client.auth/1","doc":"Issues an authentication token to access the Azure Cognitive Services API.  \nThe authentication is a Bearer token that must be passed in the Authorization header of the requests.","ref":"ExAzureSpeech.Auth.Client.html#auth/1"},{"type":"module","title":"ExAzureSpeech.Auth.Config","doc":"Configuration required to authenticate with the Azure Cognitive Services Speech Pronunciation Assessment API.","ref":"ExAzureSpeech.Auth.Config.html"},{"type":"function","title":"ExAzureSpeech.Auth.Config.get_uri/1","doc":"Returns the URI for the Azure Cognitive Services Auth API.","ref":"ExAzureSpeech.Auth.Config.html#get_uri/1"},{"type":"function","title":"ExAzureSpeech.Auth.Config.new/1","doc":"Returns a validated basic configuration for the Azure Cognitive Services Speech Pronunciation Accessment.","ref":"ExAzureSpeech.Auth.Config.html#new/1"},{"type":"type","title":"ExAzureSpeech.Auth.Config.t/0","doc":"* `:auth_key` (`t:String.t/0`) - Required. The API Key for the Azure Cognitive Services\n\n* `:region` (`t:String.t/0`) - Required. The region where the Azure Cognitive Services is hosted, eg: 'westus'","ref":"ExAzureSpeech.Auth.Config.html#t:t/0"},{"type":"type","title":"Example Configuration - ExAzureSpeech.Auth.Config.t/0","doc":"[\n      region: \"westus\",\n      auth_key: \"your_subscription_key\",\n    ]\n\nDefault global values can be set in the application configuration.  \n\n    config :ex_azure_speech,\n      region: \"westus\",\n      auth_key: \"your_subscription_key\"","ref":"ExAzureSpeech.Auth.Config.html#t:t/0-example-configuration"},{"type":"exception","title":"ExAzureSpeech.Auth.Errors.Failure","doc":"Represents an unexpected authentication error.","ref":"ExAzureSpeech.Auth.Errors.Failure.html"},{"type":"function","title":"ExAzureSpeech.Auth.Errors.Failure.exception/0","doc":"","ref":"ExAzureSpeech.Auth.Errors.Failure.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Auth.Errors.Failure.t/0","doc":"","ref":"ExAzureSpeech.Auth.Errors.Failure.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Auth.Errors.Unauthorized","doc":"Return when the informed API Key is not authorized to access the Azure Cognitive Services API.","ref":"ExAzureSpeech.Auth.Errors.Unauthorized.html"},{"type":"function","title":"ExAzureSpeech.Auth.Errors.Unauthorized.exception/0","doc":"","ref":"ExAzureSpeech.Auth.Errors.Unauthorized.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Auth.Errors.Unauthorized.t/0","doc":"","ref":"ExAzureSpeech.Auth.Errors.Unauthorized.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.BitUtils","doc":"Provides utility functions for working with binary data.","ref":"ExAzureSpeech.Common.BitUtils.html"},{"type":"function","title":"ExAzureSpeech.Common.BitUtils.chunks/2","doc":"Split a binary into chunks of size `n`.","ref":"ExAzureSpeech.Common.BitUtils.html#chunks/2"},{"type":"module","title":"ExAzureSpeech.Common.ConnectionState","doc":"Defines the state of a websocket connection.","ref":"ExAzureSpeech.Common.ConnectionState.html"},{"type":"type","title":"ExAzureSpeech.Common.ConnectionState.state/0","doc":"All possible states for a connection.","ref":"ExAzureSpeech.Common.ConnectionState.html#t:state/0"},{"type":"type","title":"ExAzureSpeech.Common.ConnectionState.t/0","doc":"connection_id: Non-Dashered GUID for the connection.  \nstate: The current state of the connection.  \nresponses: List of responses.  \ncommand_queue: Queue of commands that will be executed in the event_loop.--\nsubscriber: The pid of the subscriber.  \ncontext: The context data of the connection.  \naudio_stream: A ReplayableAudioStream to read audio data.  \ncurrent_stage: The current stage of the websocket.  \ncallbacks: List of callbacks.  \nlast_received_message_timestamp: The timestamp of the last received message from the server.  \ntelemetry: List of telemetry data.","ref":"ExAzureSpeech.Common.ConnectionState.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.Errors","doc":"Defines the error types for the Azure Cognitive Services Speech SDK.","ref":"ExAzureSpeech.Common.Errors.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.splode_error?/2","doc":"","ref":"ExAzureSpeech.Common.Errors.html#splode_error?/2"},{"type":"type","title":"ExAzureSpeech.Common.Errors.class/0","doc":"","ref":"ExAzureSpeech.Common.Errors.html#t:class/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.class_module/0","doc":"","ref":"ExAzureSpeech.Common.Errors.html#t:class_module/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.error_class/0","doc":"","ref":"ExAzureSpeech.Common.Errors.html#t:error_class/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.FailedToDispatchCommand","doc":"Defines the error type for a failed dispatch of a command to a websocket client.","ref":"ExAzureSpeech.Common.Errors.FailedToDispatchCommand.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.FailedToDispatchCommand.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.FailedToDispatchCommand.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.FailedToDispatchCommand.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.FailedToDispatchCommand.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.Forbidden","doc":"Defines the error type for not being authorized.","ref":"ExAzureSpeech.Common.Errors.Forbidden.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.Forbidden.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Forbidden.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.Forbidden.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Forbidden.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.Internal","doc":"Define an error class for internal sdk errors.","ref":"ExAzureSpeech.Common.Errors.Internal.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.Internal.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Internal.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.Internal.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Internal.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.InvalidRequest","doc":"Defines the error type for invalid requests to Azure Services.","ref":"ExAzureSpeech.Common.Errors.InvalidRequest.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.InvalidRequest.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.InvalidRequest.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.InvalidRequest.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.InvalidRequest.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.InvalidResponse","doc":"Defines the error type for invalid responses from Azure Services.","ref":"ExAzureSpeech.Common.Errors.InvalidResponse.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.InvalidResponse.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.InvalidResponse.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.InvalidResponse.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.InvalidResponse.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.Timeout","doc":"Defines the error type for a timeout.","ref":"ExAzureSpeech.Common.Errors.Timeout.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.Timeout.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Timeout.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.Timeout.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Timeout.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.Unknown","doc":"Defines the error type for an unknown error.","ref":"ExAzureSpeech.Common.Errors.Unknown.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.Unknown.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Unknown.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.Unknown.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.Unknown.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.Common.Errors.WebsocketConnectionFailed","doc":"Defines the error type for a failed websocket connection.","ref":"ExAzureSpeech.Common.Errors.WebsocketConnectionFailed.html"},{"type":"function","title":"ExAzureSpeech.Common.Errors.WebsocketConnectionFailed.exception/0","doc":"","ref":"ExAzureSpeech.Common.Errors.WebsocketConnectionFailed.html#exception/0"},{"type":"type","title":"ExAzureSpeech.Common.Errors.WebsocketConnectionFailed.t/0","doc":"","ref":"ExAzureSpeech.Common.Errors.WebsocketConnectionFailed.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.Guid","doc":"Globally unique identifier (GUID) generator.","ref":"ExAzureSpeech.Common.Guid.html"},{"type":"function","title":"ExAzureSpeech.Common.Guid.create_no_dash_guid/0","doc":"Create a new GUID.","ref":"ExAzureSpeech.Common.Guid.html#create_no_dash_guid/0"},{"type":"type","title":"ExAzureSpeech.Common.Guid.t/0","doc":"Non-Dashed GUID, eg: 'C9A2E4D3D2D74C8A8B9E8C5E8A8D2B2F'","ref":"ExAzureSpeech.Common.Guid.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.HeaderNames","doc":"Common header names used in the Azure Cognitive Services API","ref":"ExAzureSpeech.Common.HeaderNames.html"},{"type":"macro","title":"ExAzureSpeech.Common.HeaderNames.values/0","doc":"","ref":"ExAzureSpeech.Common.HeaderNames.html#values/0"},{"type":"type","title":"ExAzureSpeech.Common.HeaderNames.t/0","doc":"","ref":"ExAzureSpeech.Common.HeaderNames.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.Messages.AudioMessage","doc":"Represents an audio message to be sent over a socket. The audio itself can be streammed in chunks.  \n\nPath: audio  \nContent-Type: audio/x-wav or audio/ogg  \nMessageType: binary  \n\nSupported formats:  \n- WAV (with PCM 16-bit samples, 16 kHz sample rate, and a single channel).  \n- OGG (with Opus codec, 16 kHz sample rate, and a single channel).","ref":"ExAzureSpeech.Common.Messages.AudioMessage.html"},{"type":"function","title":"ExAzureSpeech.Common.Messages.AudioMessage.end_of_stream/0","doc":"Creates an audio message with no body, this is used to signal the end of the audio stream.","ref":"ExAzureSpeech.Common.Messages.AudioMessage.html#end_of_stream/0"},{"type":"function","title":"ExAzureSpeech.Common.Messages.AudioMessage.new/1","doc":"Creates a new audio message.","ref":"ExAzureSpeech.Common.Messages.AudioMessage.html#new/1"},{"type":"type","title":"ExAzureSpeech.Common.Messages.AudioMessage.t/0","doc":"content: The audio content chunk in a byte array format.\nsize: The size of the audio content in bytes.","ref":"ExAzureSpeech.Common.Messages.AudioMessage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.Messages.MessageType","doc":"Defines the type of message to be sent.","ref":"ExAzureSpeech.Common.Messages.MessageType.html"},{"type":"type","title":"ExAzureSpeech.Common.Messages.MessageType.t/0","doc":"0 - Text message  \n1 - Binary message","ref":"ExAzureSpeech.Common.Messages.MessageType.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage","doc":"Message used to inform the Speech service about which SDK is being used and the type of audio it should expect.  \n\nPath: speech.config  \nContent-Type: application/json  \nMessageType: text","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html"},{"type":"function","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.new/0","doc":"Creates a new SpeechConfigMessage.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#new/0"},{"type":"type","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.audio/0","doc":"source: The audio source configuration.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#t:audio/0"},{"type":"type","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.context/0","doc":"system: The system information.  \nos: The os information.  \naudio: The audio information.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#t:context/0"},{"type":"type","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.os/0","doc":"name: The name of the os.  \nversion: The version of the os.  \nplatform: The platform of the os.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#t:os/0"},{"type":"type","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.source/0","doc":"bitspersample: The number of bits per sample.  \nchannelcount: The number of channels.  \nconnectivity: The connectivity of the audio source.  \nmanufacturer: The manufacturer of the audio source.  \nmodel: The model of the audio source.  \nsamplerate: The sample rate of the audio source.  \ntype: The type of the audio source.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#t:source/0"},{"type":"type","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.system/0","doc":"name: The name of the system sdk.  \nversion: The version of the system sdk.  \nbuild: The build of the system sdk.  \nlang: The programming language of the system sdk.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#t:system/0"},{"type":"type","title":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.t/0","doc":"context: The context of the message.  \nrecognition: The type of recognition to be performed.","ref":"ExAzureSpeech.Common.Messages.SpeechConfigMessage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.OutputFormats","doc":"Module for defining the supported output formats for the Azure Speech service.","ref":"ExAzureSpeech.Common.OutputFormats.html"},{"type":"macro","title":"ExAzureSpeech.Common.OutputFormats.values/0","doc":"","ref":"ExAzureSpeech.Common.OutputFormats.html#values/0"},{"type":"type","title":"ExAzureSpeech.Common.OutputFormats.t/0","doc":"","ref":"ExAzureSpeech.Common.OutputFormats.html#t:t/0"},{"type":"protocol","title":"ExAzureSpeech.Common.Protocols.Json","doc":"Protocol for deserialize JSON responses into valid message structs.","ref":"ExAzureSpeech.Common.Protocols.Json.html"},{"type":"function","title":"ExAzureSpeech.Common.Protocols.Json.from_json/2","doc":"Serializes the informed JSON string and coerces it into the informed struct.","ref":"ExAzureSpeech.Common.Protocols.Json.html#from_json/2"},{"type":"type","title":"ExAzureSpeech.Common.Protocols.Json.t/0","doc":"All the types that implement this protocol.","ref":"ExAzureSpeech.Common.Protocols.Json.html#t:t/0"},{"type":"protocol","title":"ExAzureSpeech.Common.Protocols.SocketMessage","doc":"Defines a protocol for building a message to be sent over a socket.","ref":"ExAzureSpeech.Common.Protocols.SocketMessage.html"},{"type":"function","title":"ExAzureSpeech.Common.Protocols.SocketMessage.build_message/2","doc":"Builds a message to be sent over a socket.","ref":"ExAzureSpeech.Common.Protocols.SocketMessage.html#build_message/2"},{"type":"type","title":"ExAzureSpeech.Common.Protocols.SocketMessage.t/0","doc":"All the types that implement this protocol.","ref":"ExAzureSpeech.Common.Protocols.SocketMessage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.QueryParameterNames","doc":"Common query parameter names used in the Azure Cognitive Services API","ref":"ExAzureSpeech.Common.QueryParameterNames.html"},{"type":"macro","title":"ExAzureSpeech.Common.QueryParameterNames.values/0","doc":"","ref":"ExAzureSpeech.Common.QueryParameterNames.html#values/0"},{"type":"type","title":"ExAzureSpeech.Common.QueryParameterNames.t/0","doc":"","ref":"ExAzureSpeech.Common.QueryParameterNames.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.ReplayableAudioStream","doc":"Implements a way to read audio-streams with the capability to rewing and restart from a specific offset point.","ref":"ExAzureSpeech.Common.ReplayableAudioStream.html"},{"type":"function","title":"ExAzureSpeech.Common.ReplayableAudioStream.read/1","doc":"Reads a chunk of audio from a streamable source, buffering it and returning the chunk. This approach allows rewinding\nthe stream to a specific offset point, replay it and continue reading from the stream from point onwards.","ref":"ExAzureSpeech.Common.ReplayableAudioStream.html#read/1"},{"type":"function","title":"ExAzureSpeech.Common.ReplayableAudioStream.shrink/1","doc":"Shrinks the buffer, discarding everything before the current offset.","ref":"ExAzureSpeech.Common.ReplayableAudioStream.html#shrink/1"},{"type":"type","title":"ExAzureSpeech.Common.ReplayableAudioStream.t/0","doc":"stream: Underlying stream of audio data.  \nbuffer: The binary buffer to hold streammed data.  \nbuffer_offset: The current offset in the buffer, each 1 increase in the offset represents 100ns of audio.  \nlast_read_offset: The last offset reead from the source stream.  \nbytes_per_second: The number of bytes per second in the audio stream. Calculated as sample_rate * bits_per_sample * channels.  \nchunk_size: The size in bytes of the chunk to read from the buffer. Note that the chunk cannot be larger than 65535 bytes.","ref":"ExAzureSpeech.Common.ReplayableAudioStream.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.Common.SocketMessage","doc":"Represents a message to be sent through the WebSocket.","ref":"ExAzureSpeech.Common.SocketMessage.html"},{"type":"function","title":"ExAzureSpeech.Common.SocketMessage.deserialize/2","doc":"Deserializes messages into a SocketMessage.","ref":"ExAzureSpeech.Common.SocketMessage.html#deserialize/2"},{"type":"function","title":"ExAzureSpeech.Common.SocketMessage.serialize/1","doc":"Serializers a SocketMessage to the expected websocket format.  \n\nText messages are serialized as headers followed by a double line break and the payload.  \nBinary messages are serialized as a 16-bit big-endian integer representing the length of the headers, followed by the headers and the payload.","ref":"ExAzureSpeech.Common.SocketMessage.html#serialize/1"},{"type":"type","title":"ExAzureSpeech.Common.SocketMessage.t/0","doc":"id: Non-Dashered GUID for the message.  \npayload:The message payload, it can be a binary or a text.  \nmessage_type: The type of the message.  \nheaders: List of headers for the message.","ref":"ExAzureSpeech.Common.SocketMessage.html#t:t/0"},{"type":"behaviour","title":"ExAzureSpeech.SpeechToText","doc":"Speech-to-Text module, which provides the functionality to recognize speech from audio input.","ref":"ExAzureSpeech.SpeechToText.html"},{"type":"behaviour","title":"Supported Formats - ExAzureSpeech.SpeechToText","doc":"Right now the recognition service supports only RIFF WAV (WAVE) audio format. The audio must be mono, with a sample rate of 16 kHz and 16-bit PCM encoding.","ref":"ExAzureSpeech.SpeechToText.html#module-supported-formats"},{"type":"callback","title":"ExAzureSpeech.SpeechToText.recognize_continous/2","doc":"Recognizes speech from the given audio input continuously. It imediately returns a stream that can be lazily consumed.","ref":"ExAzureSpeech.SpeechToText.html#c:recognize_continous/2"},{"type":"callback","title":"ExAzureSpeech.SpeechToText.recognize_once/2","doc":"Synchronously recognizes speech from the given audio input.","ref":"ExAzureSpeech.SpeechToText.html#c:recognize_once/2"},{"type":"type","title":"ExAzureSpeech.SpeechToText.opts/0","doc":"See the `SocketConfig.t()` and `SpeechContextConfig.t()` module for more information on the available options.","ref":"ExAzureSpeech.SpeechToText.html#t:opts/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Dimension","doc":"The dimension of the details returned by the speech acessment from the Steep-To-Text service.","ref":"ExAzureSpeech.SpeechToText.Dimension.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Dimension.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Dimension.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.SpeechToText.Errors.SpeechRecognitionFailed","doc":"This error fires when the Speech Service fails to recognize a speech input.","ref":"ExAzureSpeech.SpeechToText.Errors.SpeechRecognitionFailed.html"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Errors.SpeechRecognitionFailed.exception/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Errors.SpeechRecognitionFailed.html#exception/0"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Errors.SpeechRecognitionFailed.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Errors.SpeechRecognitionFailed.html#t:t/0"},{"type":"exception","title":"ExAzureSpeech.SpeechToText.Errors.WebsocketConnectionNeverStarted","doc":"This error fires up when the websocket connection with the cognitive services fails to be established.","ref":"ExAzureSpeech.SpeechToText.Errors.WebsocketConnectionNeverStarted.html"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Errors.WebsocketConnectionNeverStarted.exception/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Errors.WebsocketConnectionNeverStarted.html#exception/0"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Errors.WebsocketConnectionNeverStarted.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Errors.WebsocketConnectionNeverStarted.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.GradingSystem","doc":"The grading system to be used for pronunciation assessment.","ref":"ExAzureSpeech.SpeechToText.GradingSystem.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.GradingSystem.t/0","doc":"hundred_mark: The grading system that uses a 0 to 100-point scale.\nfive_point: The grading system that uses a 1 to 5-point scale.","ref":"ExAzureSpeech.SpeechToText.GradingSystem.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Granularity","doc":"Defines the granularity of the recognition results.","ref":"ExAzureSpeech.SpeechToText.Granularity.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Granularity.t/0","doc":"phoneme: The granularity that returns the phoneme-level recognition results.\nword: The granularity that returns the word-level recognition results.\nfulltext: The granularity that returns the fulltext-level recognition results.","ref":"ExAzureSpeech.SpeechToText.Granularity.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage","doc":"Message used to set the context of the speech to text service, such as if prosody accessment is enabled or not.  \n\nPath: speech.context  \nContent-Type: application/json  \nMessageType: text","ref":"ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage.html"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage.new/1","doc":"Create a new SpeechContextMessage with the given configuration options.","ref":"ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage.html#new/1"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Recognizer","doc":"Speech-to-Text Recognizer module, which provides the functionality to recognize speech from audio input.","ref":"ExAzureSpeech.SpeechToText.Recognizer.html"},{"type":"module","title":"Internals - ExAzureSpeech.SpeechToText.Recognizer","doc":"The communication with the Speech-to-Text API is done through a WebSocket connection. For safety and isolation purposes,\neach recognition request is handled by a separate WebSocket connection. This is achieved by spawning a new WebSocket process thats supervised by a DynamicSupervisor,\nwhich will guarantee that the WebSocket connection is properly terminated after the recognition process is done.","ref":"ExAzureSpeech.SpeechToText.Recognizer.html#module-internals"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Recognizer.child_spec/1","doc":"","ref":"ExAzureSpeech.SpeechToText.Recognizer.html#child_spec/1"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Recognizer.start_link/1","doc":"","ref":"ExAzureSpeech.SpeechToText.Recognizer.html#start_link/1"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Responses.Evaluation","doc":"Phrase details from the Speech-To-Text API.","ref":"ExAzureSpeech.SpeechToText.Responses.Evaluation.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.Evaluation.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.Evaluation.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Responses.PrimaryLanguage","doc":"Represents the primary language of the speech.","ref":"ExAzureSpeech.SpeechToText.Responses.PrimaryLanguage.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.PrimaryLanguage.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.PrimaryLanguage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Responses.SpeechPhrase","doc":"Represents a valid Speech-To-Text API response.","ref":"ExAzureSpeech.SpeechToText.Responses.SpeechPhrase.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.SpeechPhrase.recognition_status/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.SpeechPhrase.html#t:recognition_status/0"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.SpeechPhrase.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.SpeechPhrase.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Responses.Word","doc":"Represents a word in a phrase.","ref":"ExAzureSpeech.SpeechToText.Responses.Word.html"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Responses.Word.t/0","doc":"","ref":"ExAzureSpeech.SpeechToText.Responses.Word.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.SpeechToText.SocketConfig","doc":"Configurations required to establish a WebSocket connection with the Azure Cognitive Speech Service.","ref":"ExAzureSpeech.SpeechToText.SocketConfig.html"},{"type":"function","title":"ExAzureSpeech.SpeechToText.SocketConfig.get_uri/1","doc":"Returns the URI to establish a WebSocket connection with the Azure Cognitive Services Speech Service.","ref":"ExAzureSpeech.SpeechToText.SocketConfig.html#get_uri/1"},{"type":"function","title":"ExAzureSpeech.SpeechToText.SocketConfig.new/1","doc":"Returns a validated basic configuration for the Azure Cognitive Services Speech Pronunciation Accessment.","ref":"ExAzureSpeech.SpeechToText.SocketConfig.html#new/1"},{"type":"type","title":"ExAzureSpeech.SpeechToText.SocketConfig.t/0","doc":"* `:connection_id` (`t:String.t/0`) - Required. A unique identifier for the connection. This is used to correlate the recognition results with the requests.\n\n* `:auth_key` (`t:String.t/0`) - Required. The subscription key for the Azure Cognitive Services Speech Service.\n\n* `:region` (`t:String.t/0`) - Required. The region where the Azure Cognitive Services Speech Service is hosted. This is used to determine the base URL for the WebSocket connection.\n\n* `:format` - The format of the recognition results. `:simple` returns only the recognition result, while `:detailed` returns the recognition result along with the detailed pronunciation assessment. The default value is `:simple`.\n\n* `:language` (`t:String.t/0`) - Required. The language of the speech to be recognized. This is used to determine the language model to be used for recognition. E.g., 'en-US', 'fr-FR', etc.\n\n* `:recognition_mode` - The recognition mode to be used. `:interactive` is optimized for short phrases, `:conversation` is optimized for conversational speech, and `:dictation` is optimized for long-form speech. The default value is `:conversation`.","ref":"ExAzureSpeech.SpeechToText.SocketConfig.html#t:t/0"},{"type":"type","title":"Example Configuration - ExAzureSpeech.SpeechToText.SocketConfig.t/0","doc":"[\n      region: \"westus\",\n      auth_key: \"your_subscription_key\",\n      language: \"en-US\",\n      format: :simple,\n      recognition_mode: :interactive\n    ]\n\nDefault global values can be set in the application configuration.  \n\n    config :ex_azure_speech,\n      region: \"westus\",\n      auth_key: \"your_subscription_key\",\n      language: \"en-US\",\n      pronunciation_assessment: [\n        format: :simple,\n        recognition_mode: :interactive\n      ]","ref":"ExAzureSpeech.SpeechToText.SocketConfig.html#t:t/0-example-configuration"},{"type":"module","title":"ExAzureSpeech.SpeechToText.SpeechContextConfig","doc":"Configures the Speech-to-Text context.--\nTHe objective of the Speech Context is to provide more data to the Speech-to-Text service, so it can better understand the user's speech,\nit also provides configurations for speech assessment and detailed output analysis.","ref":"ExAzureSpeech.SpeechToText.SpeechContextConfig.html"},{"type":"function","title":"ExAzureSpeech.SpeechToText.SpeechContextConfig.new/1","doc":"Returns a valid configuration for the Speech-to-Text context.","ref":"ExAzureSpeech.SpeechToText.SpeechContextConfig.html#new/1"},{"type":"type","title":"ExAzureSpeech.SpeechToText.SpeechContextConfig.t/0","doc":"* `:phrase_detection` (`t:keyword/0`) - Specifies details about the phrase detection.\n\n  * `:recognition_mode` - The recognition mode to be used. `:interactive` is optimized for short phrases, `:conversation` is optimized for conversational speech, and `:dictation` is optimized for long-form speech.\n\n  * `:speech_segmentation_silence_ms` (`t:integer/0`) - The minimum length of silence that indicates the end of a phrase.\n\n* `:speech_assessment` (`t:keyword/0`) - Configuration for the speech aassesment, if not informed, assessment will not be performed.\n\n  * `:reference_text` (`t:String.t/0`) - The reference text to be used to evaluate the user's speech.  \n    This is optional for unscripted assessment. The default value is `\"\"`.\n\n  * `:grading_system` - The grading system to be used to evaluate the user's speech.  \n\n    Supported grading systems:  \n    - :five_point - The user's speech will be graded on a scale of 1 to 5.  \n    - :hundred_mark - The user's speech will be graded on a scale of 0 to 100.\n\n    The default value is `:five_point`.\n\n  * `:granularity` - The granularity to be used to evaluate the user's speech.  \n\n    Supported granularities:  \n    - :phoneme - The user's speech will be evaluated at the phoneme level.  \n    - :word - The user's speech will be evaluated at the word level.  \n    - :fulltext - The user's speech will be evaluated at the full text level.\n\n    The default value is `:phoneme`.\n\n  * `:dimension` - How many dimensions will be outputted for the user's speech.  \n\n    Supported dimensions:  \n    - :comprehensive - All dimensions will be outputted.  \n    - :basic - Only the basic dimensions will be outputted.\n\n    The default value is `:comprehensive`.\n\n  * `:enable_prosody_assessment` (`t:boolean/0`) - If the prosody assessment should be enabled or not. The default value is `false`.\n\n  * `:enable_miscue` (`t:boolean/0`) - If miscues should be validated in the prosody assessment. The default value is `false`.","ref":"ExAzureSpeech.SpeechToText.SpeechContextConfig.html#t:t/0"},{"type":"type","title":"Example Configuration - ExAzureSpeech.SpeechToText.SpeechContextConfig.t/0","doc":"[\n      phrase_detection: [\n        speech_segmentation_silence_ms: 500\n      ],\n      speech_assessment: [\n        reference_text: \"The quick brown fox jumps over the lazy dog.\",\n        grading_system: :five_point,\n        granularity: :phoneme,\n        dimension: :comprehensive,\n        enable_prosody_assessment: true,\n        enable_miscue: true\n      ]\n    ]","ref":"ExAzureSpeech.SpeechToText.SpeechContextConfig.html#t:t/0-example-configuration"},{"type":"module","title":"ExAzureSpeech.SpeechToText.Websocket","doc":"Websocket Connection with the Azure Cognitive Services Speech-to-Text service.  \n\nThe SpeechSDK internals is straightforward and works like this:\n\n1. Open a websocket connection to the Azure Cognitive Services Speech-to-Text service.\n2. The client sends a `ExAzureSpeech.Common.Messages.SpeechConfigMessage` informing the basic configuration for the recognition.\n3. The client sends a `ExAzureSpeech.SpeechToText.Messages.SpeechContextMessage` to configure the context of the recognition, with language,\nif it should run a pronunciation assessment and so on.\n4. The Server process the data and answers with a speech.startDetected followed by a turn.start message, indicating that its ready to receive the audio input.\n5. The client sends the audio input in chunks using the `ExAzureSpeech.Common.Messages.AudioMessage` message.\n6. The client sends a `ExAzureSpeech.Common.Messages.AudioMessage.end_of_stream` message to indicate the end of the audio input. (optional)\n7. The client waits for the recognition response, which is a JSON object with the recognition result and optionally the pronunciation assessment.\n8. The server sends a speech.endDetected message followed by a turn.end message, indicating that the recognition is over.","ref":"ExAzureSpeech.SpeechToText.Websocket.html"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Websocket.open_connection/3","doc":"Opens a WebSocket connection with the Azure Cognitive Services Speech-to-Text service.","ref":"ExAzureSpeech.SpeechToText.Websocket.html#open_connection/3"},{"type":"function","title":"ExAzureSpeech.SpeechToText.Websocket.process_to_stream/2","doc":"","ref":"ExAzureSpeech.SpeechToText.Websocket.html#process_to_stream/2"},{"type":"type","title":"ExAzureSpeech.SpeechToText.Websocket.expected_responses/0","doc":"All possible responses from the Azure Cognitive Services Speech-to-Text service.  \n\nspeech_start_detected: The server accepted the speech configs and contexts and will start a recognition turn.  \nturn_start: The server started a recognition turn and is waiting for audio input.  \nspeech_hypothesis: The server is processing the audio input and has a hypothesis already processed  \nspeech_end_detected: The server detected the end of the speech input and will return the results.  \nspeech_phrase: The server has a recognition result.  \nturn_end: The server ended the recognition turn and the connection is ready for a new recognition turn or to being closed.","ref":"ExAzureSpeech.SpeechToText.Websocket.html#t:expected_responses/0"},{"type":"behaviour","title":"ExAzureSpeech.TextToSpeech","doc":"Azure Text-to-Speech module, which provides the functionality to synthesize text into speech.","ref":"ExAzureSpeech.TextToSpeech.html"},{"type":"callback","title":"ExAzureSpeech.TextToSpeech.speak_ssml/3","doc":"Synthesizes the given SSML into speech.  \n\nParameters:  \n- `ssml`: The SSML to synthesize.  \n- `opts`: The options for the synthesis.  \n- `callbacks`: The callbacks for the synthesis. See `ExAzureSpeech.TextToSpeech.Websocket.callbacks()`.","ref":"ExAzureSpeech.TextToSpeech.html#c:speak_ssml/3"},{"type":"callback","title":"ExAzureSpeech.TextToSpeech.speak_text/5","doc":"Synthesizes the given text into speech.  \n\nParameters:  \n- `text`: The text to synthesize.  \n- `voice`: The voice to use for the synthesis. E.g: en-US-AriaNeural  \n- `language`: The language code for the synthesis. E.g: en-US  \n- `opts`: The options for the synthesis.  \n- `callbacks`: The callbacks for the synthesis. See `ExAzureSpeech.TextToSpeech.Websocket.callbacks()`","ref":"ExAzureSpeech.TextToSpeech.html#c:speak_text/5"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.opts/0","doc":"The options for the Text-to-Speech Synthesizer module.","ref":"ExAzureSpeech.TextToSpeech.html#t:opts/0"},{"type":"exception","title":"ExAzureSpeech.TextToSpeech.Errors.SpeechSynthError","doc":"This error fires when the Speech Service fails to recognize a speech input.","ref":"ExAzureSpeech.TextToSpeech.Errors.SpeechSynthError.html"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.Errors.SpeechSynthError.exception/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Errors.SpeechSynthError.html#exception/0"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Errors.SpeechSynthError.t/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Errors.SpeechSynthError.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage","doc":"Message used to set the context of the text to speech service.  \n\nPath: synthesis.context  \nContent-Type: application/json  \nMessageType: text","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage.html"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage.new/1","doc":"Creates a new SynthesisContextMessage struct.","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage.html#new/1"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage.t/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage","doc":"Message used to request a text synthesis, this is a SSML.  \n\nPath: ssml  \nContent-Type: application/ssml+xml  \nMessageType: text","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.html"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.ssml/1","doc":"Creates a new SynthesisMessage with the given SSML payload.","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.html#ssml/1"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.text/3","doc":"Creates a new SynthesisMessage with the given text, voice, and language.","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.html#text/3"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.t/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage.html#t:t/0"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata","doc":"Represents metadata responses from the Azure Text to Speech service.","ref":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.html"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.sentence_boundary/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.html#t:sentence_boundary/0"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.session_end/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.html#t:session_end/0"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.t/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.html#t:t/0"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.viseme/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.html#t:viseme/0"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.word_boundary/0","doc":"","ref":"ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.html#t:word_boundary/0"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.SocketConfig","doc":"Module for defining the configuration for the Text-to-Speech WebSocket connection.","ref":"ExAzureSpeech.TextToSpeech.SocketConfig.html"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.SocketConfig.get_uri/1","doc":"Returns the URI for the Text-to-Speech WebSocket connection.","ref":"ExAzureSpeech.TextToSpeech.SocketConfig.html#get_uri/1"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.SocketConfig.new/1","doc":"Returns a validated configuration for the Text-to-Speech WebSocket connection.","ref":"ExAzureSpeech.TextToSpeech.SocketConfig.html#new/1"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.SocketConfig.t/0","doc":"* `:connection_id` (`t:String.t/0`) - Required. A unique identifier for the connection. This is used to correlate the recognition results with the requests.\n\n* `:auth_key` (`t:String.t/0`) - Required. The subscription key for the Azure Cognitive Services Speech Service.\n\n* `:region` (`t:String.t/0`) - Required. The region where the Azure Cognitive Services Speech Service is hosted. This is used to determine the base URL for the WebSocket connection.\n\n* `:endpoint_id` (`t:String.t/0`) - Endpoint ID for the custom voice. This is required when using a custom voice model.","ref":"ExAzureSpeech.TextToSpeech.SocketConfig.html#t:t/0"},{"type":"type","title":"Example Configuration - ExAzureSpeech.TextToSpeech.SocketConfig.t/0","doc":"[\n    connection_id: \"my-connection-id\",\n    region: \"eastus\",\n    auth_key: \"my-auth-key\",\n    endpoint_id: \"my-endpoint-id\"\n  ]","ref":"ExAzureSpeech.TextToSpeech.SocketConfig.html#t:t/0-example-configuration"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig","doc":"Configures the Text-to-Speech Synthesis context.","ref":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.html"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.new/1","doc":"Returns a valid configuration for the Text-to-Speech context.","ref":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.html#new/1"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.t/0","doc":"* `:audio` (`t:keyword/0`) - The default value is `[]`.\n\n  * `:metadata_options` (`t:keyword/0`) - The default value is `[]`.\n\n    * `:bookmark_enabled` (`t:boolean/0`) - The default value is `false`.\n\n    * `:punctuation_boundary_enabled` (`t:boolean/0`) - Specifies whether punctuation boundary data should be included in the output. The default value is `true`.\n\n    * `:sentence_boundary_enabled` (`t:boolean/0`) - Specifies whether sentence boundary data should be included in the output. The default value is `true`.\n\n    * `:word_boundary_enabled` (`t:boolean/0`) - Specifies whether word boundary data should be included in the output. The default value is `false`.\n\n    * `:session_end_enabled` (`t:boolean/0`) - Specifies whether session end data should be included in the output. The default value is `false`.\n\n    * `:viseme_enabled` (`t:boolean/0`) - Specifies whether viseme data should be included in the output. The default value is `false`.\n\n  * `:output_format` (`ExAzureSpeech.Common.OutputFormats.t()`) - Specifies the output format for the audio. The default value is `\"riff-24khz-16bit-mono-pcm\"`.\n\n* `:language` (`t:keyword/0`) - The default value is `[]`.\n\n  * `:auto_detection` (`t:boolean/0`) - Specifies whether the language should be automatically detected. The default value is `false`.","ref":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.html#t:t/0"},{"type":"type","title":"Example Configuration - ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.t/0","doc":"[\n      audio: [\n        metadata_options: [\n          bookmark_enabled: false,\n          punctuation_boundary_enabled: true,\n          sentence_boundary_enabled: true,\n          word_boundary_enabled: false,\n          session_end_enabled: false,\n          viseme_enabled: false\n        ],\n        output_format: \"riff-24khz-16bit-mono-pcm\"\n      ],\n      language: [\n        auto_detection: false\n      ]\n    ]","ref":"ExAzureSpeech.TextToSpeech.SpeechSynthesisConfig.html#t:t/0-example-configuration"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.Synthesizer","doc":"Text-to-Speech Synthesizer module, which provides the functionality to synthesize text into speech.","ref":"ExAzureSpeech.TextToSpeech.Synthesizer.html"},{"type":"module","title":"ExAzureSpeech.TextToSpeech.Websocket","doc":"Module for handling the websocket connection to the Azure Text to Speech service.  \n\nThe Text-to-Speech webhook internals are implemented like this:  \n\n1. Opens a WebSocket connection to the Azure Text to Speech service.  \n2. The client sends a `ExAzureSpeech.Common.Messages.SpeechConfigMessage` informing the basic configuration for the recognition.  \n3. The client sends a `ExAzureSpeech.TextToSpeech.Messages.SynthesisContextMessage` informing the synthesis context.  \n4. The client sends a `ExAzureSpeech.TextToSpeech.Messages.SynthesisMessage` to start the synthesis.  \n5. The client receives audio metadata from the service. Which can be processed by the asynchronous callbacks  \n6. The client receives audio data from the service in a binary format  \n7. The client receives a `ExAzureSpeech.TextToSpeech.Responses.AudioMetadata.session_end` message when the synthesis ends.","ref":"ExAzureSpeech.TextToSpeech.Websocket.html"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.Websocket.open_connection/3","doc":"Opens a connection to the Azure Text to Speech service.","ref":"ExAzureSpeech.TextToSpeech.Websocket.html#open_connection/3"},{"type":"function","title":"ExAzureSpeech.TextToSpeech.Websocket.synthesize/3","doc":"Synthesises the given text using the Azure Text to Speech service.","ref":"ExAzureSpeech.TextToSpeech.Websocket.html#synthesize/3"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Websocket.callbacks/0","doc":"Callbacks for handling audio metadata.  \n\nviseme_callback: Executes everytime an Viseme metadata is received.  \nword_boundary_callback: Executes everytime an Word Boundary metadata is received.  \nsentence_boundary_callback: Executes everytime an Sentence Boundary metadata is received.  \nsession_end_callback: Executes everytime an Session End metadata is received.","ref":"ExAzureSpeech.TextToSpeech.Websocket.html#t:callbacks/0"},{"type":"type","title":"ExAzureSpeech.TextToSpeech.Websocket.expected_responses/0","doc":"Expected websocket frame responses from the Azure Text-to-Speech Service.  \n\nturn_start: The start of a new synthesis turn.  \nresponse: Returns info from a stream, nothing useful.--\naudio_metadata: Returns metadata about the audio. Like boundaries, visemes, etc.  \naudio: Returns the audio data in binary format.  \nturn_end: The end of a synthesis turn.","ref":"ExAzureSpeech.TextToSpeech.Websocket.html#t:expected_responses/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## [0.2.2](https://github.com/ex-azure/ex_azure_speech/compare/v0.2.1...v0.2.2) (2024-10-25)","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Update dependencies ([#43](https://github.com/ex-azure/ex_azure_speech/issues/43)) ([3f35feb](https://github.com/ex-azure/ex_azure_speech/commit/3f35feb52a8b362238f5dfe2f9e276edf5902e82))\n* Websocket connections should be closed on any error ([a9b8125](https://github.com/ex-azure/ex_azure_speech/commit/a9b8125f2612468b623c34688286e0737ef89416))\n\n## [0.2.1](https://github.com/ex-azure/ex_azure_speech/compare/v0.2.0...v0.2.1) (2024-07-29)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* **audio-recognition:** EndOfDictation messages replaced last detected recognition. ([#39](https://github.com/ex-azure/ex_azure_speech/issues/39)) ([68f6aea](https://github.com/ex-azure/ex_azure_speech/commit/68f6aeaaf7df9c28b92c701dd01afc23e00c4bad))\n* **deps:** Dependencies update ([09d77ce](https://github.com/ex-azure/ex_azure_speech/commit/09d77ced08b6c9bee259ba65b2f581cc3d96ea88))\n\n## [0.2.0](https://github.com/YgorCastor/ex_azure_speech/compare/v0.1.1...v0.2.0) (2024-04-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - Changelog","doc":"* **text_to_speech:** Implements text-to-speech ([#16](https://github.com/YgorCastor/ex_azure_speech/issues/16)) ([46c058e](https://github.com/YgorCastor/ex_azure_speech/commit/46c058e0487ca02299c39714ad72105ac4795455))","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Improved handling of errors ([2f4fde4](https://github.com/YgorCastor/ex_azure_speech/commit/2f4fde43b937c13cad10fe57b10e7d2e86e18ac3))\n\n## [0.1.1](https://github.com/YgorCastor/ex_azure_speech/compare/v0.1.0...v0.1.1) (2024-04-25)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* **continuous_speech:** Delegates the connection shutdown to the websocket ([b3f9a9d](https://github.com/YgorCastor/ex_azure_speech/commit/b3f9a9d6b1f2554cb8a3f7cab54aaf97d75c671d))\n* **pronunciation_assessment:** Added FullText pronunciation granularity ([d3e6713](https://github.com/YgorCastor/ex_azure_speech/commit/d3e67134165eba654255a063ecd083e6f2a8226b))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"0.1.0 (2024-04-19) - Changelog","doc":"","ref":"changelog.html#0-1-0-2024-04-19"},{"type":"extras","title":"Features - Changelog","doc":"* **continuous_recognition:** Implements asynchronous recognition.  ([#12](https://github.com/YgorCastor/ex_azure_speech/issues/12)) ([863847f](https://github.com/YgorCastor/ex_azure_speech/commit/863847fe570d5427642437616c846cb306b182e6))","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Added utility to deal with in-memory streams ([6851389](https://github.com/YgorCastor/ex_azure_speech/commit/68513899c157d567e182b463f77720add9d10474))\n* Changed type Phrase to Evaluation ([2479ddd](https://github.com/YgorCastor/ex_azure_speech/commit/2479ddddc6a146ba4d604c3f3d0b4c36c9dee04a))\n* Moving speech context to the connection state ([18a4820](https://github.com/YgorCastor/ex_azure_speech/commit/18a48200584ef2491e4f694e50d960673a21ca3c))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Miscellaneous Chores - Changelog","doc":"* Preparing Release ([30a1468](https://github.com/YgorCastor/ex_azure_speech/commit/30a1468af1159f9830c78f554f293b715b8ac4d3))","ref":"changelog.html#miscellaneous-chores"},{"type":"extras","title":"Introduction","doc":"# ExAzureSpeech\n\n[![Hex](https://img.shields.io/hexpm/v/ex_azure_speech?style=flat-square)](https://hex.pm/packages/ex_azure_speech)\n[![.github/workflows/build_and_test.yaml](https://github.com/YgorCastor/ex_azure_speech/actions/workflows/build_and_test.yaml/badge.svg)](https://github.com/YgorCastor/ex_azure_speech/actions/workflows/build_and_test.yaml)\n\nThe non-official Elixir implementation for Azure Cognitive Services Speech SDK. This project aims to provide all the functionalities described in the [official speech sdk](https://learn.microsoft.com/en-gb/azure/ai-services/speech-service/) for Elixir Projects.","ref":"readme.html"},{"type":"extras","title":"Getting Started - Introduction","doc":"To use the Elixir Speech SDK you first need to add the dependency in your `mix.exs` file.\n\n```elixir\ndef deps do\n  [\n    {:ex_azure_speech, \"~> 0.1.0\"}\n  ]\nend\n```\n\nOptionally, you can add the following configuration to your `config.exs` file, to globally configure all the SDK basic settings.\n```elixir\nconfig :ex_azure_speech,\n  region: \"westeurope\",\n  language: \"en-US\",\n  auth_key: \"YOUR_AZURE_SUBSCRIPTION_KEY\"\n```","ref":"readme.html#getting-started"},{"type":"extras","title":"Implemented Modules - Introduction","doc":"","ref":"readme.html#implemented-modules"},{"type":"extras","title":"Speech-to-Text with Pronunciation Assessment - Introduction","doc":"To configure the speech-to-text module, you need to add the following module to your supervision tree.\n\n```elixir\nchildren = [\n  ExAzureSpeech.SpeechToText.Recognizer\n]\n\nSupervisor.start_link(children, strategy: :one_for_one)\n```\n\n#### Example\n```elixir\nFile.stream!(\"test.wav\") |> SpeechToText.recognize_once()\n\n{:ok,\n  [%ExAzureSpeech.SpeechToText.Responses.SpeechPhrase{\n    channel: 0,\n    display_text: \"My voice is my passport verify me.\",\n    duration: 27600000,\n    id: \"ada609c747614c118ac9df6545118646\",\n    n_best: nil,\n    offset: 7300000,\n    primary_language: nil,\n    recognition_status: \"Success\",\n    speaker_id: nil\n  }]}\n```","ref":"readme.html#speech-to-text-with-pronunciation-assessment"},{"type":"extras","title":"Text-to-Speech - Introduction","doc":"To configure the text-to-speech module, you need to add the following module to your supervision tree.\n```elixir\nchildren = [\n  ExAzureSpeech.TextToSpeech.Synthesizer\n]\n\nSupervisor.start_link(children, strategy: :one_for_one)\n```\n\n#### Example\n\n```elixir\n{:ok, stream} = TextToSpeech.speak_text(\"Hello. World.\", \"en-US-AriaNeural\", \"en-US\")\n\n{:ok, #Function<52.48886818/2 in Stream.resource/3>}\n\nstream\n|> Stream.into(File.stream!(\"hello_world.wav\"))\n|> Stream.run()\n```","ref":"readme.html#text-to-speech"},{"type":"extras","title":"Readiness - Introduction","doc":"This library is still in continuous development, so contracts and APIs may change considerably. Please, use it at your own risk.","ref":"readme.html#readiness"},{"type":"extras","title":"Roadmap - Introduction","doc":"- ~~Text-to-Speech~~\n- Translation\n- Speech Intent\n- Avatars","ref":"readme.html#roadmap"},{"type":"extras","title":"License","doc":"Copyright (c) 2024 Ygor Castor https://ygorcastor.github.io\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}